#include "rca.h"

#define SSID       ""
#define PASSWORD   ""

#define AP_SSID       "M0_AP"
#define AP_PASSWORD   "none"

#include "ESP8266.h"

ESP8266 wifi;

void setup()
{
    Serial.println("Web Server Task : Start!");
    
    wifi.begin(Serial5, 115200);
    
    Serial.print("FW Version:");
    Serial.println(wifi.getVersion().c_str());
    
#if 1
    if (wifi.setOprToStation()) {
        Serial.print("to station ok\r\n");
    } else {
        Serial.print("to station err\r\n");
    }
    
    if (wifi.joinAP(SSID, PASSWORD)) {
        Serial.print("Join AP success\r\n");
        Serial.print("IP: ");
        Serial.println(wifi.getLocalIP().c_str());    
    } else {
        Serial.print("Join AP failure\r\n");
    }
#else
    if (wifi.setOprToSoftAP()) {
        Serial.print("to softap ok\r\n");
    } else {
        Serial.print("to softap err\r\n");
    }
    
    if(wifi.setSoftAPParam(AP_SSID, AP_PASSWORD, 7, 0)){
        Serial.print("Set SoftAP success\r\n");
        Serial.print("IP: ");
        Serial.println(wifi.getLocalIP().c_str());            
    }
    else {
        Serial.print("Set SoftAP failure\r\n");
    }
#endif
    if (wifi.enableMUX()) {
        Serial.print("multiple ok\r\n");
    } else {
        Serial.print("multiple err\r\n");
    }
    
    if (wifi.startTCPServer(80)) {
        Serial.print("start tcp server ok\r\n");
    } else {
        Serial.print("start tcp server err\r\n");
    }

    if (wifi.setTCPServerTimeout(10)) { 
        Serial.print("set tcp server timout 10 seconds\r\n");
    } else {
        Serial.print("set tcp server timout err\r\n");
    }
    
    Serial.print("setup end\r\n");
}


void loop()
{
    uint8_t mux_id;
    uint8_t buffer[128] = {0};
    uint32_t len = wifi.recv(&mux_id, buffer, sizeof(buffer));
    
    if(len == 0) {
        return;
    }
    
    Serial.println("Web Server Task : Recive Request");
        
    String cmd = (char*)buffer;

    wifi.send(mux_id, cmd);
    wifi.releaseTCP(mux_id);
}
